## mir 2.11.0+dfsg

=== CMakeLists.txt ===
# Copyright © 2012-2017 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 or 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.16)

cmake_policy(SET CMP0015 NEW)
cmake_policy(SET CMP0022 NEW)

set(CMAKE_GCOV gcov)

project(Mir)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

set(MIR_VERSION_MAJOR 2)
set(MIR_VERSION_MINOR 11)
set(MIR_VERSION_PATCH 0)

add_compile_definitions(MIR_VERSION_MAJOR=${MIR_VERSION_MAJOR})
add_compile_definitions(MIR_VERSION_MINOR=${MIR_VERSION_MINOR})
add_compile_definitions(MIR_VERSION_MICRO=${MIR_VERSION_PATCH})
add_compile_definitions(_GNU_SOURCE)
add_compile_definitions(_FILE_OFFSET_BITS=64)

set(MIR_VERSION ${MIR_VERSION_MAJOR}.${MIR_VERSION_MINOR}.${MIR_VERSION_PATCH})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
execute_process(
  COMMAND ${CMAKE_CXX_COMPILER} -dumpmachine
  OUTPUT_VARIABLE TARGET_ARCH
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

option(use_debflags "Use build flags from dpkg-buildflags." OFF)
if(use_debflags)
  include (cmake/Debian.cmake)
endif()
include (cmake/EnableCoverageReport.cmake)
include (cmake/MirCommon.cmake)
include (GNUInstallDirs)
include (cmake/Doxygen.cmake)

set(build_types "None;Debug;Release;RelWithDebInfo;MinSizeRel;Coverage;AddressSanitizer;ThreadSanitizer;UBSanitizer")
# Change informational string for CMAKE_BUILD_TYPE
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "${build_types}" FORCE)
# Enable cmake-gui to display a drop down list for CMAKE_BUILD_TYPE
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "${build_types}")

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g -Wall -pedantic -Wextra -fPIC")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -g -Wall -fno-strict-aliasing -pedantic -Wnon-virtual-dtor -Wextra -fPIC")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--as-needed")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")

set(MIR_FATAL_COMPILE_WARNINGS ON CACHE BOOL "Should compiler warnings fail the build")
if(MIR_FATAL_COMPILE_WARNINGS)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

set(MIR_COMPILER_QUIRKS "" CACHE STRING "Semicolon-separated list of compiler quirks to enable")

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wmismatched-tags HAS_W_MISMATCHED_TAGS)

if(HAS_W_MISMATCHED_TAGS)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-mismatched-tags")
endif()

# GCC 7.1 fixed a bug in the ARM ABI, which results in some std::vector methods
# (among others) generating this warning.
#
# There's nothing we can do about it; everything just needs to be rebuilt with
# GCC 7.1.
check_cxx_compiler_flag(-Wpsabi HAS_W_PSABI)
if(HAS_W_PSABI)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
endif()

set(MIR_USE_LD ld CACHE STRING "Linker to use")
set_property(CACHE MIR_USE_LD PROPERTY STRINGS "ld;gold;lld;mold")
if(MIR_USE_LD MATCHES "gold")
  set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fuse-ld=gold")
  set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fuse-ld=gold")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=gold")
endif()
if(MIR_USE_LD MATCHES "lld")
  set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fuse-ld=lld")
  set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fuse-ld=lld")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=lld")
endif()
if(MIR_USE_LD MATCHES "mold")
  set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fuse-ld=mold")
  set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fuse-ld=mold")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=mold")
endif()

# Link time optimization allows leaner, cleaner libraries
option(MIR_LINK_TIME_OPTIMIZATION "Enables the linker to optimize binaries." OFF)
if(MIR_LINK_TIME_OPTIMIZATION)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -flto")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
  if(${CMAKE_COMPILER_IS_GNUCXX})
    # clang defaults to fat LTO, but gcc needs an option to specify
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffat-lto-objects")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ffat-lto-objects")
    set(CMAKE_NM "gcc-nm")
    set(CMAKE_AR "gcc-ar")
    set(CMAKE_RANLIB "gcc-ranlib")
  endif()
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES "coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs")
endif()

if(cmake_build_type_lower MATCHES "addresssanitizer")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fsanitize=address")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=address")
  if (CMAKE_COMPILER_IS_GNUCXX)
    # Work around GCC bug. It should automatically link to asan when
    # -fsanitize=address is used, but doesn't.
    #
    # Linking everything with asan is harmless and simple, so do that.
    link_libraries(asan) # Workaround for LP:1413474
  endif()
elseif(cmake_build_type_lower MATCHES "threadsanitizer")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-omit-frame-pointer")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=thread -fno-omit-frame-pointer")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fsanitize=thread")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=thread")
  if (CMAKE_COMPILER_IS_GNUCXX)
    # Work around GCC bug. It should automatically link to tsan when
    # -fsanitize=thread is used, but doesn't.
    #
    # Linking everything with tsan is harmless and simple, so do that.
    link_libraries(tsan) # Workaround for LP:1413474
  endif()
elseif(cmake_build_type_lower MATCHES "ubsanitizer")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined -fno-omit-frame-pointer")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=undefined -fno-omit-frame-pointer")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fsanitize=undefined")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=undefined")
  # "Symbol already defined" errors occur with pre-compiled headers
  SET(MIR_USE_PRECOMPILED_HEADERS OFF CACHE BOOL "Use precompiled headers" FORCE)
  if (CMAKE_COMPILER_IS_GNUCXX)
    # Work around GCC bug. It should automatically link to asan when
    # -fsanitize=undefined is used, but doesn't.
    #
    # Linking everything with ubsan is harmless and simple, so do that.
    link_libraries(ubsan) # Workaround for LP:1413474
  endif()
  # We have inline classes as interfaces used by .so's and implemented elsewhere.
  # This results in multiple trivial implementations. So let's not warn about that.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-sanitize=vptr")
else()
  # AddressSanitizer builds fail if we disallow undefined symbols
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-undefined")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--no-undefined")
endif()

enable_testing()
find_package(PkgConfig)

# Check for boost
find_package(Boost 1.48.0 COMPONENTS date_time system program_options filesystem iostreams REQUIRED)
include_directories (SYSTEM
  ${Boost_INCLUDE_DIRS}
)

add_compile_definitions(EGL_NO_X11)
add_compile_definitions(MESA_EGL_NO_X11_HEADERS) # Can be removed when all platforms support EGL_NO_X11

pkg_check_modules(WAYLAND_EGLSTREAM wayland-eglstream)

# Set the default platforms based on availability of NVIDIA libraries
if (WAYLAND_EGLSTREAM_FOUND)
  set(
    MIR_PLATFORM
    gbm-kms;x11;eglstream-kms;wayland
    CACHE
    STRING
    "a list of graphics backends to build (options are 'gbm-kms', 'x11', 'eglstream-kms', 'wayland', or 'rpi-dispmanx')"
  )
else()
  set(
    MIR_PLATFORM
    gbm-kms;x11;wayland
    CACHE
    STRING
    "a list of graphics backends to build (options are 'gbm-kms', 'x11', 'eglstream-kms', 'wayland', or 'rpi-dispmanx')"
  )
endif()

list(GET MIR_PLATFORM 0 MIR_TEST_PLATFORM)

option(MIR_ENABLE_TESTS "Build tests" ON)
CMAKE_DEPENDENT_OPTION(
  MIR_ENABLE_WLCS_TESTS "Also Build WLCS tests" ON
  "MIR_ENABLE_TESTS" OFF
)
CMAKE_DEPENDENT_OPTION(
  MIR_RUN_WLCS_TESTS "Run WLCS tests as part of testsuite" ON
  "MIR_ENABLE_WLCS_TESTS" OFF
)
CMAKE_DEPENDENT_OPTION(
  MIR_BAD_BUFFER_TEST_ENVIRONMENT_BROKEN "Expect WLCS BadBuffer tests to fail" OFF
  "MIR_RUN_WLCS_TESTS" OFF
)


foreach(platform IN LISTS MIR_PLATFORM)
  if (platform STREQUAL "gbm-kms")
    set(MIR_BUILD_PLATFORM_GBM_KMS TRUE)
  endif()
  if (platform STREQUAL "x11")
     set(MIR_BUILD_PLATFORM_X11 TRUE)
  endif()
  if (platform STREQUAL "eglstream-kms")
     if (NOT WAYLAND_EGLSTREAM_FOUND)
        message(FATAL_ERROR "EGLStream platform requested, but required NVIDIA external EGL platform nvidia-egl-wayland not found")
     endif()
     set(MIR_BUILD_PLATFORM_EGLSTREAM_KMS TRUE)
  endif()
  if (platform STREQUAL "wayland")
     set(MIR_BUILD_PLATFORM_WAYLAND TRUE)
  endif()
  if (platform STREQUAL "rpi-dispmanx")
    set(MIR_BUILD_PLATFORM_RPI_DISPMANX TRUE)
    pkg_check_modules(BCM_HOST REQUIRED bcm_host)
  endif()
endforeach(platform)

find_package(EGL REQUIRED)
find_package(GLESv2 REQUIRED)
find_package(GLM REQUIRED)
find_package(GLog REQUIRED)
find_package(GFlags REQUIRED)

pkg_check_modules(LTTNG_UST REQUIRED lttng-ust>=2.9)
pkg_check_modules(UDEV REQUIRED libudev)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-2.0 gio-unix-2.0)
pkg_check_modules(WAYLAND_SERVER REQUIRED wayland-server)
pkg_check_modules(WAYLAND_CLIENT REQUIRED wayland-client)
pkg_check_modules(XCB REQUIRED xcb)
pkg_check_modules(XCB_COMPOSITE REQUIRED xcb-composite)
pkg_check_modules(XCB_XFIXES REQUIRED xcb-xfixes)
pkg_check_modules(XCB_RENDER REQUIRED xcb-render)
pkg_check_modules(X11_XCURSOR REQUIRED xcursor)
pkg_check_modules(DRM REQUIRED libdrm)

include_directories (SYSTEM ${GLESv2_INCLUDE_DIRS})
include_directories (SYSTEM ${EGL_INCLUDE_DIRS})
include_directories (SYSTEM ${GLM_INCLUDE_DIRS})

include(CheckCXXSymbolExists)
list(APPEND CMAKE_REQUIRED_INCLUDES ${DRM_INCLUDE_DIRS})
list(APPEND CMAKE_REQUIRED_LIBRARIES ${DRM_LIBRARIES})

# Add USDT hooks to all LTTNG tracepoints
#
# This might be gnarly; this tweaks an LTTNG header to enable its
# USDT integration. The integration only involves #include-ing a

=== src/server/CMakeLists.txt ===
pkg_check_modules(UUID REQUIRED uuid)
pkg_check_modules(FREETYPE freetype2 REQUIRED) # For rendering decorated window titles

add_compile_definitions(
  MIR_LOG_COMPONENT_FALLBACK="mirserver"
  MIR_VERSION="${MIR_VERSION}"
)

include_directories(
  ${PROJECT_SOURCE_DIR}/include/server
  ${PROJECT_SOURCE_DIR}/include/renderer
  ${PROJECT_SOURCE_DIR}/include/renderers/gl
  ${PROJECT_SOURCE_DIR}/include/renderers/sw
  ${PROJECT_SOURCE_DIR}/src/include/platform
  ${PROJECT_SOURCE_DIR}/src/include/client
  ${PROJECT_SOURCE_DIR}/src/include/server
  ${PROJECT_SOURCE_DIR}/src/include/cookie
  ${PROJECT_SOURCE_DIR}/src/include/wayland
  ${GLIB_INCLUDE_DIRS}
  ${GIO_INCLUDE_DIRS}
)
add_compile_definitions(MIR_SERVER_INPUT_PLATFORM_VERSION="${MIR_SERVER_INPUT_PLATFORM_VERSION}")

add_compile_definitions(MIR_SERVER_PLATFORM_PATH="${MIR_SERVER_PLATFORM_PATH}")
add_compile_definitions(MIR_SERVER_GRAPHICS_PLATFORM_VERSION="${MIR_SERVER_GRAPHICS_PLATFORM_VERSION}")

add_subdirectory(compositor/)
add_subdirectory(graphics/)
add_subdirectory(input/)
add_subdirectory(report/)
add_subdirectory(scene/)
add_subdirectory(frontend/)
add_subdirectory(frontend_wayland/)
add_subdirectory(frontend_xwayland/)
add_subdirectory(shell/)
add_subdirectory(console/)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/mirserver.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/mirserver.pc
  @ONLY
)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/version.h.in
  ${PROJECT_SOURCE_DIR}/include/server/mir/version.h
)

add_library(mirserverobjects OBJECT
  run_mir.cpp
  report_exception.cpp
  terminate_with_current_exception.cpp
  display_server.cpp
  default_server_configuration.cpp
  glib_main_loop.cpp
  glib_main_loop_sources.cpp
  default_emergency_cleanup.cpp
  server.cpp
  lockable_callback_wrapper.cpp
  basic_callback.cpp
  ${PROJECT_SOURCE_DIR}/src/include/server/mir/time/alarm_factory.h
  ${PROJECT_SOURCE_DIR}/src/include/server/mir/time/alarm.h
  ${PROJECT_SOURCE_DIR}/src/include/server/mir/observer_registrar.h
  ${PROJECT_SOURCE_DIR}/src/include/server/mir/observer_multiplexer.h
  ${PROJECT_SOURCE_DIR}/src/include/server/mir/glib_main_loop.h
  ${PROJECT_SOURCE_DIR}/src/include/server/mir/glib_main_loop_sources.h
)

target_link_libraries(mirserverobjects
  PUBLIC
    mirplatform
    mircommon
    mircookie
    mircore
)

set_property(
    SOURCE glib_main_loop.cpp glib_main_loop_sources.cpp default_server_configuration.cpp
    PROPERTY COMPILE_OPTIONS -Wno-variadic-macros)

set(MIR_SERVER_OBJECTS
  $<TARGET_OBJECTS:mirserverobjects>
  $<TARGET_OBJECTS:mirinput>
  $<TARGET_OBJECTS:mirscene>
  $<TARGET_OBJECTS:mircompositor>
  $<TARGET_OBJECTS:mirgraphics>
  $<TARGET_OBJECTS:mirfrontend>
  $<TARGET_OBJECTS:mirfrontend-wayland>
  $<TARGET_OBJECTS:mirfrontend-xwayland>
  $<TARGET_OBJECTS:mirshell>
  $<TARGET_OBJECTS:mirshelldecoration>
  $<TARGET_OBJECTS:mirlttng>
  $<TARGET_OBJECTS:mirreport>
  $<TARGET_OBJECTS:mirlogging>
  $<TARGET_OBJECTS:mirnullreport>
  $<TARGET_OBJECTS:mirconsole>

  $<TARGET_OBJECTS:mirrenderergl>
  $<TARGET_OBJECTS:mirgl>
)

set(MIR_SERVER_REFERENCES
  ${DRM_LDFLAGS}
  ${EGL_LIBRARIES}
  ${GL_LDFLAGS}
  ${EPOXY_LDFLAGS}
  ${UDEV_LDFLAGS}
  ${GLIB_LDFLAGS}
  ${GIO_LDFLAGS}
  ${UUID_LDFLAGS}
  ${LTTNG_UST_LDFLAGS}
)

set(MIR_SERVER_OBJECTS ${MIR_SERVER_OBJECTS} PARENT_SCOPE)
set(MIR_SERVER_REFERENCES ${MIR_SERVER_REFERENCES} PARENT_SCOPE)

add_library(mirserver SHARED
  ${MIR_SERVER_OBJECTS}
)

target_link_libraries(mirserver
  PUBLIC


    mirplatform
    mircommon
    mircookie
    mirwayland

    server_platform_common
    ${DRM_LDFLAGS}
    ${EGL_LIBRARIES}
    ${GL_LDFLAGS}
    ${EPOXY_LDFLAGS}
    ${UDEV_LDFLAGS}
    ${GLIB_LDFLAGS}
    ${GIO_LDFLAGS}
    ${UUID_LDFLAGS}
    ${XCB_LDFLAGS}
    ${XCB_COMPOSITE_LDFLAGS}
    ${XCB_XFIXES_LDFLAGS}
    ${XCB_RENDER_LDFLAGS}
    ${X11_XCURSOR_LDFLAGS}
    ${LTTNG_UST_LDFLAGS}
    ${FREETYPE_LDFLAGS}
    atomic
)

target_include_directories(mirshelldecoration
  PRIVATE
    ${FREETYPE_INCLUDE_DIRS}
)

target_include_directories(mirshell
  PUBLIC
    ${UUID_INCLUDE_DIRS}
)

set(MIRSERVER_INCLUDE_DIRS ${UUID_INCLUDE_DIRS} PARENT_SCOPE)

install(TARGETS mirserver
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)
install(DIRECTORY
  ${CMAKE_SOURCE_DIR}/include/platform/mir DESTINATION "include/mirplatform"
)
install(DIRECTORY
  ${CMAKE_SOURCE_DIR}/include/server/mir DESTINATION "include/mirserver"
)

set(MIRSERVER_ABI 58) # Be sure to increment MIR_VERSION_MINOR at the same time
set(symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols.map)

set_target_properties(
  mirserver

  PROPERTIES
  SOVERSION ${MIRSERVER_ABI}
  LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mirserver.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== src/wayland/CMakeLists.txt ===
set(MIRWAYLAND_ABI 4)
set(symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols.map)
add_compile_definitions(MIR_LOG_COMPONENT_FALLBACK="mirwayland")

add_subdirectory(generator/)

set(STANDARD_SOURCES
  lifetime_tracker.cpp
  resource.cpp
  global.cpp
  protocol_error.cpp
  client.cpp
)

add_library(mirwayland SHARED
    ${STANDARD_SOURCES}
)

mir_generate_protocol_wrapper(mirwayland "wl_"   protocol/wayland.xml)
mir_generate_protocol_wrapper(mirwayland "z"     protocol/xdg-shell-unstable-v6.xml)
mir_generate_protocol_wrapper(mirwayland ""      protocol/xdg-shell.xml)
mir_generate_protocol_wrapper(mirwayland "z"     protocol/xdg-output-unstable-v1.xml)
mir_generate_protocol_wrapper(mirwayland "zwlr_" protocol/wlr-layer-shell-unstable-v1.xml)
mir_generate_protocol_wrapper(mirwayland "zwlr_" protocol/wlr-foreign-toplevel-management-unstable-v1.xml)
mir_generate_protocol_wrapper(mirwayland "zwp_"  protocol/pointer-constraints-unstable-v1.xml)
mir_generate_protocol_wrapper(mirwayland "zwp_"  protocol/relative-pointer-unstable-v1.xml)
mir_generate_protocol_wrapper(mirwayland "zwp_"  protocol/virtual-keyboard-unstable-v1.xml)
mir_generate_protocol_wrapper(mirwayland "zwp_"  protocol/text-input-unstable-v3.xml)
mir_generate_protocol_wrapper(mirwayland "zwp_"  protocol/text-input-unstable-v2.xml)
mir_generate_protocol_wrapper(mirwayland "zwp_"  protocol/text-input-unstable-v1.xml)
mir_generate_protocol_wrapper(mirwayland "zwp_"  protocol/input-method-unstable-v2.xml)
mir_generate_protocol_wrapper(mirwayland "zwp_"  protocol/idle-inhibit-unstable-v1.xml)
mir_generate_protocol_wrapper(mirwayland "z"     protocol/wlr-screencopy-unstable-v1.xml)
mir_generate_protocol_wrapper(mirwayland "zwlr_" protocol/wlr-virtual-pointer-unstable-v1.xml)

target_link_libraries(mirwayland
  PUBLIC
    mircore
    ${WAYLAND_SERVER_LIBRARIES}
  PRIVATE
    mircommon
)

target_include_directories(mirwayland
  PUBLIC
    ${PROJECT_SOURCE_DIR}/include/wayland
    ${PROJECT_SOURCE_DIR}/src/include/wayland
    ${CMAKE_CURRENT_BINARY_DIR}
)

set_target_properties(mirwayland
    PROPERTIES
    SOVERSION ${MIRWAYLAND_ABI}
    LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
    LINK_DEPENDS ${symbol_map}
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/mirwayland.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/mirwayland.pc
    @ONLY
)

install(TARGETS     mirwayland                           LIBRARY DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}")
install(FILES       ${CMAKE_CURRENT_BINARY_DIR}/mirwayland.pc    DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig")
install(DIRECTORY   ${CMAKE_SOURCE_DIR}/include/wayland/mir      DESTINATION "include/mirwayland")

=== tests/unit-tests/CMakeLists.txt ===
include(CMakeDependentOption)

add_compile_definitions(
  MIR_SERVER_GRAPHICS_PLATFORM_ABI_STRING="${MIR_SERVER_GRAPHICS_PLATFORM_ABI}"
)

if (MIR_BUILD_PLATFORM_GBM_KMS)
  add_compile_definitions(MIR_BUILD_PLATFORM_GBM_KMS)
endif()

if (MIR_BUILD_PLATFORM_X11)
  add_compile_definitions(MIR_BUILD_PLATFORM_X11)
endif()

if (MIR_BUILD_PLATFORM_EGLSTREAM_KMS)
  add_compile_definitions(MIR_BUILD_PLATFORM_EGLSTREAM_KMS)
endif()

include_directories(
  ${CMAKE_SOURCE_DIR}

  ${DRM_INCLUDE_DIRS}
  ${GBM_INCLUDE_DIRS}
  ${UMOCKDEV_INCLUDE_DIRS}

  ${PROJECT_SOURCE_DIR}/include/renderers/sw
  ${PROJECT_SOURCE_DIR}/src/include/cookie
  ${PROJECT_SOURCE_DIR}/src/include/platform
  ${PROJECT_SOURCE_DIR}/src/include/server
  ${PROJECT_SOURCE_DIR}/src/include/client
  ${PROJECT_SOURCE_DIR}/src/include/common
  ${PROJECT_SOURCE_DIR}/src/include/gl
  ${PROJECT_SOURCE_DIR}/src/platforms/common/client
  ${PROJECT_SOURCE_DIR}/src/platforms/common/server
  ${CMAKE_BINARY_DIR}/src/server/console
  ${GLIB_INCLUDE_DIRS}
  ${GIO_INCLUDE_DIRS}
)

add_library(example SHARED library_example.cpp)
target_link_libraries(example mircommon)
set_target_properties(
  example PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/test-data/shared-libraries
  OUTPUT_NAME example
  PREFIX ""
)

# Umockdev uses glib, which uses the deprecated "register" allocation specifier
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Dregister=")

set(UMOCK_UNIT_TEST_SOURCES test_udev_wrapper.cpp)

set(
  UNIT_TEST_SOURCES

  test_recursive_read_write_mutex.cpp
  test_glib_main_loop.cpp
  shared_library_test.cpp
  test_raii.cpp
  test_variable_length_array.cpp
  test_default_emergency_cleanup.cpp
  test_thread_safe_list.cpp
  test_fatal.cpp
  test_fd.cpp
  test_flags.cpp
  test_shared_library_prober.cpp
  test_lockable_callback.cpp
  test_module_deleter.cpp
  test_mir_cookie.cpp
  test_posix_rw_mutex.cpp
  test_posix_timestamp.cpp
  test_observer_multiplexer.cpp
  test_edid.cpp
  test_report_exception.cpp
  test_thread_pool_executor.cpp
  test_linearising_executor.cpp
)

if (HAVE_PTHREAD_GETNAME_NP)
  list(APPEND UNIT_TEST_SOURCES test_thread_name.cpp)
else()
  message(WARNING "pthread_getname_np() not supported: Omitting test_thread_name.cpp which relies on it")
endif()

CMAKE_DEPENDENT_OPTION(
  MIR_RUN_UNIT_TESTS
  "Run unit tests as part of default testing"
  ON
  "MIR_BUILD_UNIT_TESTS"
  OFF)

add_subdirectory(compositor/)
add_subdirectory(console/)
add_subdirectory(dispatch/)
add_subdirectory(frontend_wayland/)
add_subdirectory(frontend_xwayland/)
add_subdirectory(geometry/)
add_subdirectory(gl/)
add_subdirectory(graphics/)
add_subdirectory(input/)
add_subdirectory(logging/)
add_subdirectory(options/)
add_subdirectory(platforms/)
add_subdirectory(renderers/gl)
add_subdirectory(scene/)
add_subdirectory(shell/)
add_subdirectory(wayland/)

if (NOT HAVE_PTHREAD_GETNAME_NP)
  set_source_files_properties (
    ${CMAKE_CURRENT_SOURCE_DIR}/dispatch/test_threaded_dispatcher.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/frontend/test_basic_connector.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/compositor/test_multi_threaded_compositor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_thread_pool_executor.cpp

    PROPERTIES COMPILE_DEFINITIONS MIR_DONT_USE_PTHREAD_GETNAME_NP
  )
  message(WARNING "pthread_getname_np() not supported: Disabling test_threaded_dispatcher.cpp tests that rely on it")
  message(WARNING "pthread_getname_np() not supported: Disabling test_basic_connector.cpp tests that rely on it")
  message(WARNING "pthread_getname_np() not supported: Disabling test_multi_threaded_compositor.cpp tests that rely on it")
  message(WARNING "pthread_getname_np() not supported: Disabling test_threaded_snapshot_strategy.cpp tests that rely on it")
  message(WARNING "pthread_getname_np() not supported: Disabling test_thread_pool_executor.cpp tests that rely on it")
endif()

link_directories(${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

mir_add_wrapped_executable(mir_unit_tests NOINSTALL
  ${UNIT_TEST_SOURCES}
  $<TARGET_OBJECTS:mir-libinput-test-framework>
  $<TARGET_OBJECTS:mir-test-doubles-udev>

  ${MIR_SERVER_OBJECTS}
  ${MIR_PLATFORM_OBJECTS}
)

set_property(
  SOURCE test_udev_wrapper.cpp test_glib_main_loop.cpp
  SOURCE console/test_logind_console_services.cpp
  SOURCE input/test_logind_console_services.cpp input/test_input_platform_probing.cpp
  SOURCE input/evdev/test_evdev_input_platform.cpp
  SOURCE graphics/test_platform_prober.cpp
  PROPERTY COMPILE_OPTIONS -Wno-variadic-macros)

if ("test_linearising_executor.cpp:use-after-free" IN_LIST MIR_COMPILER_QUIRKS)
  set_property(
    SOURCE test_linearising_executor.cpp
    PROPERTY COMPILE_OPTIONS -Wno-error=use-after-free  # riscv64 spuriously warns here
  )
endif()

if (MIR_USE_PRECOMPILED_HEADERS)
  target_precompile_headers(
    mir_unit_tests
    PRIVATE
      <gmock/gmock.h>
      <gtest/gtest.h>
      <vector>
      <string>
      <exception>
      <memory>
  )
endif()

add_dependencies(mir_unit_tests GMock)

set_target_properties(
  mir_unit_tests
  PROPERTIES
    ENABLE_EXPORTS TRUE
)

target_link_libraries(
  mir_unit_tests

  exampleserverconfig
  mircommon
  server_platform_common

  mir-test-static
  mir-test-framework-static

  mircommon

  ${Boost_LIBRARIES}
  ${WAYLAND_SERVER_LDFLAGS}
  ${CMAKE_THREAD_LIBS_INIT} # Link in pthread.
)

mir_add_wrapped_executable(mir_umock_unit_tests NOINSTALL
  ${UMOCK_UNIT_TEST_SOURCES}
  $<TARGET_OBJECTS:mir-umock-test-framework>
  $<TARGET_OBJECTS:mir-test-input-framework>
  ${MIR_SERVER_OBJECTS}
  ${MIR_PLATFORM_OBJECTS}
)

string(REGEX MATCH "^[0-9]*\.[0-9]*" UMOCKDEV_VERSION_MINOR ${UMOCKDEV_VERSION})
set_source_files_properties(${UMOCK_UNIT_TEST_SOURCES} PROPERTIES COMPILE_DEFINITIONS UMOCKDEV_VERSION=${UMOCKDEV_VERSION_MINOR})

add_dependencies(mir_umock_unit_tests GMock)

set_target_properties(
  mir_umock_unit_tests
  PROPERTIES
    ENABLE_EXPORTS TRUE
)

target_link_libraries(
  mir_umock_unit_tests

  exampleserverconfig
  mircommon

  mir-test-static
  mir-test-framework-static

  ${Boost_LIBRARIES}
  ${UMOCKDEV_LDFLAGS}
  ${LIBINPUT_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT} # Link in pthread.
)

target_link_libraries(mir_unit_tests

  mir-test-doubles-static
  mir-test-doubles-platform-static
  )

target_link_libraries(mir_umock_unit_tests

  mir-test-doubles-static
  mir-test-doubles-platform-static
  )

if (MIR_RUN_UNIT_TESTS)
  mir_discover_tests_with_fd_leak_detection(mir_unit_tests G_SLICE=always-malloc G_DEBUG=gc-friendly)
  mir_discover_tests_with_fd_leak_detection(mir_umock_unit_tests LD_PRELOAD=libumockdev-preload.so.0 G_SLICE=always-malloc G_DEBUG=gc-friendly)
endif (MIR_RUN_UNIT_TESTS)

add_custom_command(TARGET mir_unit_tests POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E copy_directory
  ${CMAKE_CURRENT_SOURCE_DIR}/shared-libraries ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/test-data/shared-libraries
  COMMENT "Copying test data to build dir..."
)
add_library(loadable_test_dso SHARED ${CMAKE_CURRENT_SOURCE_DIR}/shared-libraries/empty_input.c)

set_target_properties(loadable_test_dso PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/test-data/shared-libraries
  COMPILE_FLAGS "-Wno-pedantic"
  OUTPUT_NAME this-arch
)

add_dependencies(mir_unit_tests loadable_test_dso)

mir_add_test(NAME unit-tests-do-not-link-with-GL-or-EGL
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/bin
      COMMAND /bin/sh -c "!(objdump -p *unit_tests* | grep NEEDED | grep GL)")

add_custom_command(TARGET mir_unit_tests POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E copy_directory
  ${CMAKE_CURRENT_SOURCE_DIR}/dbus ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/test-data/dbus
  COMMENT "Copying dbus-daemon configuration to build dir..."
)

=== tests/acceptance-tests/wayland/CMakeLists.txt ===
pkg_check_modules(WLCS REQUIRED wlcs)
include_directories(${WLCS_INCLUDE_DIRS})

add_library(
  miral_wlcs_integration MODULE

  miral_integration.cpp
  test_wlcs_display_server.cpp test_wlcs_display_server.h
)

target_link_libraries(
  miral_wlcs_integration

  mir-test-assist
  ${WAYLAND_CLIENT_LDFLAGS}
)

set(SYMBOL_FILE ${CMAKE_CURRENT_SOURCE_DIR}/symbol.map)

set_target_properties(
  miral_wlcs_integration PROPERTIES

  PREFIX ""
  LINK_FLAGS "-Wl,--version-script,${SYMBOL_FILE}"
  LINK_DEPENDS ${SYMBOL_FILE}
)

pkg_get_variable(WLCS_BINARY wlcs test_runner)

set(EXPECTED_FAILURES

  ClientSurfaceEventsTest.frame_timestamp_increases
  ClientSurfaceEventsTest.surface_gets_enter_event
  ClientSurfaceEventsTest.surface_gets_leave_event
  SubsurfaceTest.place_above_simple
  SubsurfaceTest.place_below_simple
  TouchInputSubsurfaces/SubsurfaceMultilevelTest.subsurface_moves_after_both_sync_parent_and_grandparent_commit/0
  TouchInputSubsurfaces/SubsurfaceMultilevelTest.subsurface_with_desync_parent_moves_when_only_parent_committed/0
  TouchInputSubsurfaces/SubsurfaceTest.desync_subsurface_moves_when_only_parent_committed/0
  TouchInputSubsurfaces/SubsurfaceTest.one_subsurface_to_another_fallthrough/0
  TouchInputSubsurfaces/SubsurfaceTest.place_above_simple/0
  TouchInputSubsurfaces/SubsurfaceTest.place_below_simple/0
  TouchInputSubsurfaces/SubsurfaceTest.pointer_input_correctly_offset_for_subsurface/0
  TouchInputSubsurfaces/SubsurfaceTest.subsurface_does_not_move_when_parent_not_committed/0
  TouchInputSubsurfaces/SubsurfaceTest.subsurface_extends_parent_input_region/0
  TouchInputSubsurfaces/SubsurfaceTest.subsurface_moves_out_from_under_input_device/0
  TouchInputSubsurfaces/SubsurfaceTest.subsurface_moves_under_input_device_once/0
  TouchInputSubsurfaces/SubsurfaceTest.subsurface_moves_under_input_device_twice/0
  TouchInputSubsurfaces/SubsurfaceTest.sync_subsurface_moves_when_only_parent_committed/0
  WlShellSubsurfaces/SubsurfaceMultilevelTest.subsurface_moves_after_both_sync_parent_and_grandparent_commit/0
  WlShellSubsurfaces/SubsurfaceMultilevelTest.subsurface_with_desync_parent_moves_when_only_parent_committed/0
  WlShellSubsurfaces/SubsurfaceTest.desync_subsurface_moves_when_only_parent_committed/0
  WlShellSubsurfaces/SubsurfaceTest.one_subsurface_to_another_fallthrough/0
  WlShellSubsurfaces/SubsurfaceTest.place_above_simple/0
  WlShellSubsurfaces/SubsurfaceTest.place_below_simple/0
  WlShellSubsurfaces/SubsurfaceTest.pointer_input_correctly_offset_for_subsurface/0
  WlShellSubsurfaces/SubsurfaceTest.subsurface_does_not_move_when_parent_not_committed/0
  WlShellSubsurfaces/SubsurfaceTest.subsurface_extends_parent_input_region/0
  WlShellSubsurfaces/SubsurfaceTest.sync_subsurface_moves_when_only_parent_committed/0
  XdgShellStableSubsurfaces/SubsurfaceMultilevelTest.subsurface_moves_after_both_sync_parent_and_grandparent_commit/0
  XdgShellStableSubsurfaces/SubsurfaceMultilevelTest.subsurface_with_desync_parent_moves_when_only_parent_committed/0
  XdgShellStableSubsurfaces/SubsurfaceTest.desync_subsurface_moves_when_only_parent_committed/0
  XdgShellStableSubsurfaces/SubsurfaceTest.one_subsurface_to_another_fallthrough/0
  XdgShellStableSubsurfaces/SubsurfaceTest.place_above_simple/0
  XdgShellStableSubsurfaces/SubsurfaceTest.place_below_simple/0
  XdgShellStableSubsurfaces/SubsurfaceTest.pointer_input_correctly_offset_for_subsurface/0
  XdgShellStableSubsurfaces/SubsurfaceTest.subsurface_does_not_move_when_parent_not_committed/0
  XdgShellStableSubsurfaces/SubsurfaceTest.subsurface_extends_parent_input_region/0
  XdgShellStableSubsurfaces/SubsurfaceTest.sync_subsurface_moves_when_only_parent_committed/0
  XdgShellV6Subsurfaces/SubsurfaceMultilevelTest.subsurface_moves_after_both_sync_parent_and_grandparent_commit/0
  XdgShellV6Subsurfaces/SubsurfaceMultilevelTest.subsurface_with_desync_parent_moves_when_only_parent_committed/0
  XdgShellV6Subsurfaces/SubsurfaceTest.desync_subsurface_moves_when_only_parent_committed/0
  XdgShellV6Subsurfaces/SubsurfaceTest.one_subsurface_to_another_fallthrough/0
  XdgShellV6Subsurfaces/SubsurfaceTest.place_above_simple/0
  XdgShellV6Subsurfaces/SubsurfaceTest.place_below_simple/0
  XdgShellV6Subsurfaces/SubsurfaceTest.pointer_input_correctly_offset_for_subsurface/0
  XdgShellV6Subsurfaces/SubsurfaceTest.subsurface_does_not_move_when_parent_not_committed/0
  XdgShellV6Subsurfaces/SubsurfaceTest.subsurface_extends_parent_input_region/0
  XdgShellV6Subsurfaces/SubsurfaceTest.sync_subsurface_moves_when_only_parent_committed/0
  XdgSurfaceStableTest.attaching_buffer_to_unconfigured_xdg_surface_is_an_error
  XdgSurfaceStableTest.creating_xdg_surface_from_wl_surface_with_attached_buffer_is_an_error
  XdgSurfaceStableTest.creating_xdg_surface_from_wl_surface_with_committed_buffer_is_an_error
  XdgSurfaceStableTest.creating_xdg_surface_from_wl_surface_with_existing_role_is_an_error
  XdgToplevelStableTest.pointer_leaves_surface_during_interactive_move
  XdgToplevelStableTest.pointer_leaves_surface_during_interactive_resize
  XdgToplevelV6Test.pointer_leaves_surface_during_interactive_move
  XdgToplevelV6Test.pointer_leaves_surface_during_interactive_resize

  AllSurfaceTypes/TouchTest.sends_touch_up_on_surface_destroy/4 # Fixed by https://github.com/MirServer/wlcs/pull/199
  AllSurfaceTypes/TouchTest.sends_touch_up_on_surface_destroy/5 # Fixed by https://github.com/MirServer/wlcs/pull/199

  ForeignToplevelHandleTest.can_maximize_foreign_while_fullscreen # https://github.com/MirServer/mir/issues/2164

  # See https://github.com/MirServer/mir/issues/2324
  TextInputV3WithInputMethodV2Test.text_input_enters_parent_surface_after_child_destroyed
  TextInputV3WithInputMethodV2Test.text_input_enters_grabbing_popup
  XdgPopupUnstableV6/XdgPopupTest.grabbed_popup_gets_keyboard_focus/0
  XdgPopupStable/XdgPopupTest.grabbed_popup_gets_keyboard_focus/0
  LayerShellPopup/XdgPopupTest.grabbed_popup_gets_keyboard_focus/0
)

if (MIR_BAD_BUFFER_TEST_ENVIRONMENT_BROKEN)
  list(APPEND EXPECTED_FAILURES BadBufferTest.test_truncated_shm_file)
endif ()

set(BROKEN_TESTS
  ClientSurfaceEventsTest.buffer_release # Has been removed upstream
)

if (MIR_RUN_WLCS_TESTS)
  mir_discover_external_gtests(
    NAME wlcs
    COMMAND ${WLCS_BINARY}
    ARGS ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/miral_wlcs_integration.so
    EXPECTED_FAILURES ${EXPECTED_FAILURES}
    BROKEN_TESTS ${BROKEN_TESTS}
  )
endif()

install(TARGETS miral_wlcs_integration LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/mir)

add_custom_target(
  list_missing_wlcs_xfail_tests

  COMMAND
    ${CMAKE_COMMAND}
      -DWLCS_BINARY=${WLCS_BINARY}
      -DWLCS_INTEGRATION=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/miral_wlcs_integration.so
      -DTESTS_TO_QUERY="${EXPECTED_FAILURES}"
      -P ${CMAKE_CURRENT_SOURCE_DIR}/print_missing_wlcs_tests.cmake
)

=== debian/changelog ===
mir (2.11.0+dfsg-4) unstable; urgency=medium

  * Re-upload as is to unstable.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 13 Jan 2023 13:21:20 +0100

mir (2.11.0+dfsg-3) experimental; urgency=medium

  [ Mike Gabriel ]
  * debian/control: Work-around libmiral{5,-dev} having another version
    number when depending on other Mir bin:pkgs of the same build.

 -- Marius Gripsgard <marius@ubports.com>  Mon, 09 Jan 2023 23:09:26 +0100

mir (2.11.0+dfsg-2) experimental; urgency=medium

  * debian/patches:
    + Trivial rebase of patches 1002, 2001 and 2022.
    + Add 1003_typo-fixes.patch and 1004_sh-using-bashisms.patch.
  * debian/control:
    + Drop duplicate B-D libxcb-composite0-dev.
    + Add B-Ds: symlinks, rdfind.
  * debian/rules:
    + Apply symlinks and rdfind to API doc files.
  * debian/copyright:
    + Update once more, drop now unused license texts.
  * debian/libmir*.symbols:
    + Add Build-Depends-Package: meta data fields.
  * debian/man/:
    + Drop maintainer man pages for binaries removed from Mir upstream.
  * debian/mir-test-tools.manpages:
    + Adjust to man page removal.
  * lintian:
    + Adjust overrides to new lintian syntax.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 09 Jan 2023 15:40:38 +0100

mir (2.11.0+dfsg-1) experimental; urgency=medium

  * Upload to experimental.

  [ Marius Gripsgard ]
  * New upstream release.
  * debian/*:
    + Adjust to build mir 2.11.
  * debian/patches:
    + Drop upstreamed patches.
    + Refresh patches.

  [ Mike Gabriel ]
  * debian/copyright:
    + Update auto-generated copyright.in file for 2.10.0.
    + Update auto-generated copyright.in file for 2.11.0.
    + Merge in copyright changes from copyright.in file, more manual fine-tuning
      needed (for 2.10.0).
    + Manually fine-tune attributions until maintainer and lintian are happy
      (for 2.10.0).
    + Adjust attributions for 2.11.0.
  * debian/source/lintian-overrides:
    + Adjust lintian overrides to Mir 2.10.0.
  * debian/control:
    + Dependency fixes missed by Marius after upstream SOVERSION bumps.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 08 Jan 2023 00:06:55 +0100

mir (1.8.2+dfsg-5) unstable; urgency=medium

  [ Anton Gladky ]
  * Add debian/.gitlab-ci.yml

  [ Mike Gabriel ]
  * debian/libmirprotobuf3.symbols:
    + Update .symbols after upload of new protobuf library. (Closes: #1025262).

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 01 Dec 2022 21:38:44 +0100

mir (1.8.2+dfsg-4) unstable; urgency=medium

  * Team upload.
  * debian/patches:
    + Fix Alpine/edge (gtest).
    + Fix FTBFS with GCC-12. (Closes: #1012998)
  * debian/control:
    + Update standards version to 4.6.1, no changes needed.
    + Set upstream metadata fields: Repository.
  * Remove obsolete field Name from debian/upstream/metadata.

 -- Anton Gladky <gladk@debian.org>  Sat, 08 Oct 2022 08:29:30 +0200

mir (1.8.2+dfsg-3) unstable; urgency=medium

  * debian/control:
    + Switch to B-D valgrind-if-vailable.
  * debian/patches:
    + Add 1004_xlib-workaround.patch. Work around Xlib/capnproto naming conflict
      in capnproto 0.9.1. (Closes: #1006416).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 25 Feb 2022 13:52:29 +0100

mir (1.8.2+dfsg-2) unstable; urgency=medium

  * debian/patches: Update patch to include more fixes for ICE bug

 -- Marius Gripsgard <marius@ubports.com>  Wed, 26 Jan 2022 00:52:55 +0100

mir (1.8.2+dfsg-1) unstable; urgency=medium

  * New upstream release (v1.8.2)
  * debian/patches: Drop upstreamed patches
    + 0001_Fix-Rawhide-FTBFS.patch
      0002_Delete-obsolete-gmock-hack.patch
      0003_Instantiate-parameterized-test-suite-DisplayOrientat.patch
      0004_Add-missing-include.patch
      0005_Fix-compiler-errors.patch
      0006_Fix-FTBFS-when-building-with-gcc-11.patch
      0007_Fix-missing-includes-for-GCC-11.patch
  * debian/patches: Refresh patch
    + 1001_typo-fixes.patch
  * debian/patches: Add 1003-workaround-gcc-ICE-bug (Closes: 1003275)

 -- Marius Gripsgard <marius@ubports.com>  Mon, 24 Jan 2022 04:06:33 +0100

mir (1.8.0+dfsg1-19) unstable; urgency=medium

  [ Marius Gripsgard ]
  * debian/patches:
    + Add 0006_Fix-FTBFS-when-building-with-gcc-11.patch,
      0007_Fix-more-missing-includes-for-GCC-11.patch and
      0008_Fix-more-missing-includes-for-GCC-11.patch. Fix FTBFS when building
      with gcc 11. (Closes: 984239).

  [ Mike Gabriel ]
  * debian/control:
    + Bump Standards-Version: to 4.6.0. No changes needed.
  * debian/patches:
    + Comply with patch naming scheme. (See d/p/README).
    + Mark Debian-specific patches as such.
    + Add 0009_use-python3.patch. 'python' is not a valid shebang interpreter
      anymore.
  * debian/control:
    + Shorten synopsis of libmirwayland* bin:pkgs.
    + Add to R (mir-doc): python3 and python3-pil (for png2header.py script in
      examples/ folder).
  * debian/source/lintian-overrides:
    + Ignore several very-long-line-lengh-in-source-file reports. Thanks
      lintian, but these are ok.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 11 Nov 2021 09:35:39 +0100

=== debian/control ===
Source: mir
Section: x11
Priority: optional
Maintainer: Debian Mir Team <team+mir@tracker.debian.org>
Uploaders:
 Simon Quigley <tsimonq2@debian.org>,
 Christopher James Halse Rogers <raof@ubuntu.com>,
 Mike Gabriel <sunweaver@debian.org>,
 Debian UBports Team <team+ubports@tracker.debian.org>,
 Marius Gripsgard <marius@ubports.com>,
Build-Depends: cmake,
               pkg-config,
               debhelper-compat (= 13),
               doxygen,
               xsltproc,
               graphviz,
               libboost-dev,
               libboost-date-time-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-filesystem-dev,
               libdrm-dev,
               libegl1-mesa-dev,
               libgles2-mesa-dev,
               libgbm-dev,
               libglm-dev,
               libgoogle-glog-dev,
               liblttng-ust-dev,
               libxkbcommon-dev (>= 0.5),
               libumockdev-dev (>= 0.6) <!noinsttest>,
               umockdev (>= 0.8.7) <!noinsttest>,
               libudev-dev,
               libgtest-dev <!noinsttest>,
               google-mock (>= 1.6.0+svn437) <!noinsttest>,
               libxml++2.6-dev,
# only enable valgrind once it's been tested to work on each architecture:
               valgrind-if-available <!noinsttest>,
               libglib2.0-dev,
               libfreetype6-dev,
               libevdev-dev,
               libinput-dev (>= 0.21),
               uuid-dev,
               nettle-dev,
               libepoxy-dev,
               python3-pil:native,
               linux-libc-dev,
               dbus,
               python3-dbusmock <!noinsttest>,
               libxcb-composite0-dev,
               libxcb-xfixes0-dev,
               libxcb-render0-dev,
               libx11-xcb-dev,
               libxkbcommon-x11-dev,
               libxcursor-dev,
               libyaml-cpp-dev,
               libwayland-dev,
               libnvidia-egl-wayland-dev [amd64 i386],
               eglexternalplatform-dev [amd64 i386],
               systemtap-sdt-dev,
               wlcs <!noinsttest>,
               pkg-kde-tools,
               rdfind,
               symlinks,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://mir-server.io/
Vcs-Browser: https://salsa.debian.org/mir-server-team/mir
Vcs-Git: https://salsa.debian.org/mir-server-team/mir.git

#TODO: Packaging infrastructure for better dependency generation,
#      ala pkg-xorg's xviddriver:Provides and ABI detection.
Package: libmirserver58
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - server library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared library needed by server applications for Mir.

Package: libmirplatform24
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - platform library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server to interact with
 the underlying hardware platform.

Package: libmircore-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 libmircore2 (= ${binary:Version}),
Description: Mir Display Server - core library - development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains core header files required for server and/or client development.

Package: libmircommon-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libmircommon9 (= ${binary:Version}),
         libmircore-dev (= ${binary:Version}),
         libxkbcommon-dev,
         ${misc:Depends},
Breaks: mircommon-dev (<< 0.6)
Replaces: mircommon-dev (<< 0.6)
Description: Mir Display Server - common library - development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains common header files required for server and/or client development.


Package: libmirplatform-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libmirplatform24 (= ${binary:Version}),
         libmircommon-dev (= ${binary:Version}),
         libboost-program-options-dev,
         ${misc:Depends},
Breaks: libmirplatform (<< 0.6)
Replaces: libmirplatform (<< 0.6)
Description: Mir Display Server - platform library - development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files required for hardware/driver support development.

Package: libmirserver-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libmirserver58 (= ${binary:Version}),
         libmirplatform-dev (= ${binary:Version}),
         libmircommon-dev (= ${binary:Version}),
         libglm-dev,
         uuid-dev,
         ${misc:Depends},
Description: Mir Display Server - server library - development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files required to build Mir servers.

Package: mirtest-dev
Build-Profiles: <!noinsttest>
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libmircommon-dev (= ${binary:Version}),
         libmirplatform-dev (= ${binary:Version}),
         libmirserver-dev (= ${binary:Version}),
         mir-renderer-gl-dev (= ${binary:Version}),
         libboost-filesystem-dev,
         libboost-system-dev,
         ${misc:Depends},
Description: Mir Display Server - test development headers and library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files and static library for testing of server and/or client
 development.

Package: mir-demos
Architecture: linux-any
Breaks: miral-examples
Replaces: miral-examples
Provides: miral-examples (=1.5)
Depends: ${misc:Depends},
         ${shlibs:Depends},
         inotify-tools,
Recommends: dmz-cursor-theme,
            fonts-liberation,
            qtwayland5,
            xwayland,
Description: Mir Display Server - demonstration programs
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains demo applications that use the Mir display server

Package: mir-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Recommends: python3,
            python3-pil,
Description: Mir Display Server - API documentation for Mir
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 This package installs the mir API documentation.

Package: mir-test-tools
Build-Profiles: <!noinsttest>
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
         xwayland,
         glmark2-es2,
         glmark2-es2-wayland,
         mesa-utils-extra,
         dmz-cursor-theme,
Description: Mir Display Server - stress tests and other test tools
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains tools for smoke and performance testing the Mir display server

Package: mir-wlcs-integration
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Breaks: mir-test-tools (<< 2.0.0.0+dev148~)
Replaces: mir-test-tools (<< 2.0.0.0+dev148~)
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - wlcs integration
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains libraries for integration with the wlcs test suite

Package: libmircore2
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - core library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the 'core' shared library required for the Mir server and client.

Package: libmircommon9
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - common library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the 'common' shared library required for the Mir server and client.

# Longer-term these drivers should move out-of-tree
Package: mir-platform-graphics-x20
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - platform library for X11 Mesa
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server to interact with
 the X11 platform using the Mesa drivers.

Package: mir-platform-graphics-gbm-kms20
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - platform library for KMS Mesa
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server to interact with
 the hardware platform using the Mesa drivers.

Package: mir-platform-graphics-eglstream-kms20
Section: libs
Architecture: amd64 i386
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - platform library for NVIDIA
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server to interact with
 the hardware platform using the EGLStream EGL extensions, such as the
 NVIDIA binary driver.

Package: mir-platform-graphics-wayland20
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - platform library for Wayland
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server to interact with
 a "host" Wayland display server.

Package: mir-graphics-drivers-nvidia
Section: libs
Architecture: amd64 i386
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         mir-platform-graphics-eglstream-kms,
         mir-platform-graphics-x,
Description: Mir Display Server - Nvidia driver metapackage
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 This package depends on a full set of graphics drivers for Nvidia systems.

Package: mir-platform-input-evdev8
Section: libs
Architecture: linux-any
Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
include debian/opts.mk

# Needed for ccache to work in case the build directory changed
# (https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=810871)
export CCACHE_BASEDIR = $(shell pwd)

export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ -Bbuild-$(DEB_HOST_ARCH) --with pkgkde_symbolshelper

# Enable verbose debugging output from the testsuite
export MIR_SERVER_LOGGING = on
override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq ($(filter mipsel riscv64,$(DEB_HOST_ARCH)),)
ifeq ($(DEB_HOST_ARCH_ENDIAN),little)
	-GTEST_OUTPUT=xml:./ dh_auto_build -- ARGS="-V" ptest
else
	echo "Testsuite disabled on $(DEB_HOST_ARCH) due to lack of big-endian support."
endif
else
	echo "Testsuite disabled on $(DEB_HOST_ARCH) due to timeouts / slow CPU processing."
endif
else
	echo "Testsuite disabled due to DEB_BUILD_OPTIONS=\"$(DEB_BUILD_OPTIONS)\""
endif

override_dh_auto_test-indep:
	echo "Testsuite not run during arch:all builds."

COMMON_CONFIGURE_OPTIONS = \
  -DCMAKE_INSTALL_LIBEXECDIR="lib/$(DEB_HOST_MULTIARCH)/mir"\
  -DMIR_BUILD_INTERPROCESS_TESTS=OFF\
  -DMIR_FATAL_COMPILE_WARNINGS=OFF\
  -DMIR_LINK_TIME_OPTIMIZATION=ON\

ifeq ($(filter ppc64el,$(DEB_HOST_ARCH)),ppc64el)
       # Disable spurious error on GCC-12
       ifneq ($(shell gcc --version | grep '12.[[:digit:]]\+.[[:digit:]]\+$$'),)
               COMMON_CONFIGURE_OPTIONS += -DMIR_COMPILER_QUIRKS="libinput_environment.cpp:restrict"
       endif
endif
ifeq ($(filter riscv64,$(DEB_HOST_ARCH)),riscv64)
       # Disable spurious error on GCC-12
       ifneq ($(shell gcc --version | grep '12.[[:digit:]]\+.[[:digit:]]\+$$'),)
               COMMON_CONFIGURE_OPTIONS += -DMIR_COMPILER_QUIRKS="test_linearising_executor.cpp:use-after-free"
       endif
endif

# Disable LTO if optimizations are off
ifeq ($(filter noopt,$(DEB_BUILD_OPTIONS)),noopt)
	COMMON_CONFIGURE_OPTIONS += -DMIR_LINK_TIME_OPTIMIZATION=OFF
	DEB_BUILD_MAINT_OPTIONS += optimize=-lto
else
  # Disable LTO, due to failing to build
  ifneq (,$(filter $(DEB_HOST_ARCH),mips64el ppc64 s390x))
	COMMON_CONFIGURE_OPTIONS += -DMIR_LINK_TIME_OPTIMIZATION=OFF
	DEB_BUILD_MAINT_OPTIONS += optimize=-lto
  else
	COMMON_CONFIGURE_OPTIONS += -DMIR_LINK_TIME_OPTIMIZATION=ON
  endif
endif

ifneq (,$(filter noinsttest,$(DEB_BUILD_PROFILES)))
	COMMON_CONFIGURE_OPTIONS += -DMIR_ENABLE_TESTS=OFF
endif

# We can't guarantee non-Ubuntu builds will build against WLCS packages we
# control, so disable it on non-Ubuntu builds
#ifeq ($(filter Ubuntu,$(DEB_VENDOR)),)
COMMON_CONFIGURE_OPTIONS += -DMIR_RUN_WLCS_TESTS=OFF
#endif

# see, if this prevents from build failures on some exotic architectures (like e.g. mips64el):
COMMON_CONFIGURE_OPTIONS += -DMIR_USE_LD=ld

export DEB_BUILD_MAINT_OPTIONS

$(info COMMON_CONFIGURE_OPTIONS: ${COMMON_CONFIGURE_OPTIONS})
$(info DEB_BUILD_MAINT_OPTIONS: ${DEB_BUILD_MAINT_OPTIONS})

ifneq ($(filter amd64 i386,$(DEB_HOST_ARCH)),)
	AVAILABLE_PLATFORMS=gbm-kms\;x11\;wayland\;eglstream-kms
else
	AVAILABLE_PLATFORMS=gbm-kms\;x11\;wayland
endif

override_dh_auto_configure:
ifneq ($(filter armhf,$(DEB_HOST_ARCH)),)
	dh_auto_configure -- \
	  $(COMMON_CONFIGURE_OPTIONS) \
	  -DMIR_RUN_ACCEPTANCE_TESTS=OFF \
	  -DMIR_RUN_INTEGRATION_TESTS=OFF \
	  -DMIR_PLATFORM=$(AVAILABLE_PLATFORMS) \
	  $(OVERRIDE_CONFIGURE_OPTIONS)
else
	dh_auto_configure -- \
	  $(COMMON_CONFIGURE_OPTIONS) \
	  -DMIR_PLATFORM=$(AVAILABLE_PLATFORMS) \
	  $(OVERRIDE_CONFIGURE_OPTIONS)
endif
	# Run cmake again to pick up wlcs tests, because reasons?
	cmake build-$(DEB_HOST_ARCH)

# binary-only builds still need the doc files, otherwise the
# install target fails
override_dh_auto_build-arch: override_dh_auto_build-indep
	dh_auto_build

# Only build the docs when we need them
override_dh_auto_build-indep:
	dh_auto_build -- doc

override_dh_auto_install-indep:
	dh_auto_build -- DESTDIR=$(CURDIR)/debian/tmp doc-install
	cd debian/tmp/usr/share/doc/mir-doc/html/ && rdfind -makesymlinks true .
	cd debian/tmp/usr/share/doc/mir-doc/html/ && symlinks -rc .

# Reconstruct the MirAL version
MIRAL_VERSION_MAJOR = $(shell perl -n -e '/^set\(MIRAL_VERSION_MAJOR ([0-9]*)\)$$/ && print $$1' src/CMakeLists.txt)
MIRAL_VERSION_MINOR = $(shell perl -n -e '/^set\(MIRAL_VERSION_MINOR ([0-9]*)\)$$/ && print $$1' src/CMakeLists.txt)
MIRAL_VERSION_PATCH = $(shell perl -n -e '/^set\(MIRAL_VERSION_PATCH ([0-9]*)\)$$/ && print $$1' src/CMakeLists.txt)
MIRAL_RELEASE=$(MIRAL_VERSION_MAJOR).$(MIRAL_VERSION_MINOR).$(MIRAL_VERSION_PATCH)
MIRAL_VERSION=$(MIRAL_RELEASE).$(DEB_VERSION)

# TODO: we'll use a symbol file once mir is abi stable
override_dh_makeshlibs:
	dh_makeshlibs -Nlibmiral5 -V -Nmir-test-tools
	# libmiral5 *has* a symbols file, so we don't need to -V it!
	dh_makeshlibs -plibmiral5 -- -v$(MIRAL_RELEASE)

override_dh_missing:
	dh_missing --fail-missing

# Don't try to strip libraries used as test data
override_dh_strip:
	dh_strip -Xmir-test-data

# Don't try to find dependencies of libraries used as test data
override_dh_shlibdeps:
	dh_shlibdeps -Xmir-test-data

override_dh_gencontrol:
	dh_gencontrol -Nlibmiral5 -Nlibmiral-dev
	dh_gencontrol -plibmiral5 -plibmiral-dev -- -v$(MIRAL_VERSION) -V'libmiral5:Version=$(MIRAL_VERSION)'

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --repack --destdir=..
